"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
function cannotDeferOnNonNullMessage(fieldName) {
    return `@defer cannot be applied on non-nullable field "${fieldName}".`;
}
exports.cannotDeferOnNonNullMessage = cannotDeferOnNonNullMessage;
function CannotDeferNonNullableFields(context) {
    return {
        Directive(node) {
            const fieldDef = context.getFieldDef();
            if (fieldDef) {
                if (node.name.value === 'defer' && graphql_1.isNonNullType(fieldDef.type)) {
                    context.reportError(new graphql_1.GraphQLError(cannotDeferOnNonNullMessage(`${context.getParentType()}.${fieldDef.name}`), [node]));
                }
            }
        },
    };
}
exports.CannotDeferNonNullableFields = CannotDeferNonNullableFields;
//# sourceMappingURL=CannotDeferNonNullableFields.js.map